<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\validate\land;


use app\common\validate\BaseValidate;
use think\facade\Db;

/**
 * Product验证器
 * Class ProductValidate
 * @package app\adminapi\validate\land
 */
class ProductValidate extends BaseValidate
{

     /**
      * 设置校验规则
      * @var string[]
      */
    protected $rule = [
        'id' => 'require',
        'device_id' => 'require',
        'code' => 'require',
        'name' => 'require',
    ];

    /**
     * 参数描述
     * @var string[]
     */
    protected $field = [
        'id' => 'id',
        'code' => '产品编号',
        'name' => '产品名称',
    ];


    /**
     * @notes 添加场景
     * @return ProductValidate
     * @author likeadmin
     * @date 2023/11/25 16:16
     */
    public function sceneAdd()
    {
        return $this->only(['code','name']);
    }


    /**
     * @notes 编辑场景
     * @return ProductValidate
     * @author likeadmin
     * @date 2023/11/25 16:16
     */
    public function sceneEdit()
    {
        return $this->only(['id','code','name']);
    }


    /**
     * @notes 删除场景
     * @return ProductValidate
     * @author likeadmin
     * @date 2023/11/25 16:16
     */
    public function sceneDelete()
    {
        return $this->only(['id'])->append('id', 'require|checkProduct');
    }


    /**
     * @notes 详情场景
     * @return ProductValidate
     * @author likeadmin
     * @date 2023/11/25 16:16
     */
    public function sceneDetail()
    {
        return $this->only(['id']);
    }

    public function checkProduct($value, $rule, $data)
    {
        $productDevice = Db::name('product_device')->where('product_id', $value)->findOrEmpty();
        if (!empty($productDevice)) {
            return '存在关联设备，无法删除';
        }
        return true;
    }

   /**
     * @notes 绑定设备
     * @return LandValidate
     * @author likeadmin
     * @date 2023/11/22 16:35
     */
    public function sceneBind()
    {
        return $this->only(['id', 'device_id']);
    }

}